--- a property needed for the correctness of bitonic sort ---

-- # import Property

D : Set
(<=) : D -> D -> Prop
meet : D -> D -> D
sup : D -> D -> D

infix 6 <=

ref  : (x : D) -> (y:D) -> (x <= y /\ y <= x   <=>   Eq D x y)
axM : (x : D) -> (y : D) -> (z : D) ->
	      ( z <= meet x y	<=>
		z <= x /\ z <= y
	      )
axS : (x : D) -> (y : D) -> (z : D) ->
	      ( sup x y	<= z <=>
		x <= z /\ y <= z
	      )

remM1 : (x:D) -> (y:D) -> meet x y <= x
remM1 = \ x -> \ y -> fol-plugin(ref,axM)

remM2 : (x:D) -> (y:D) -> meet x y <= y
remM2 = \ x -> \ y -> fol-plugin(ref,axM)

remS1 : (x:D) -> (y:D) -> x <= sup x y
remS1 = \ x -> \ y -> fol-plugin(ref,axS)

remS2 : (x:D) -> (y:D) -> y <= sup x y
remS2 = \ x -> \ y -> fol-plugin(ref,axS)

--- trans can be derived
--- notice that distributivity is not needed

trans : (x:D) -> (y:D) -> (z:D) -> (x <= y /\ y <= z ==> x <= z)

lemD1 : (x:D) -> (y:D) -> (z:D) -> (t:D) -> 
          (x <= y ==> meet x z <= sup y t)
lemD1 = fol-plugin(trans,axM,axS,remM1,remS1)

lemD2 : (x:D) -> (y:D) -> (z:D) -> (t:D) -> 
          (t <= z ==> meet y t <= sup x z)
lemD2 = fol-plugin(trans,axM,axS,remM2,remS2)

lemD3 : (x:D) -> (y:D) -> (z:D) -> (t:D) -> 
          (y <= z ==> meet y t <= sup x z)
lemD3 = fol-plugin(trans,axM,axS,remM1,remS2)

lemD4 : (x:D) -> (y:D) -> (z:D) -> (t:D) -> 
          (z <= y ==> meet x z <= sup y t)
lemD4 = fol-plugin(trans,axM,axS,remM2,remS1)


-- the index set ---

I : Set
(<) : I -> I -> Prop

axI : (i:I) -> (j:I) -> (k:I) ->
        (
            (i < j /\ j < k ==> i < k) 
         /\ (i < j \/ Eq I i j \/ j < i)
         /\ Not (i < i)
        )


bitonic : (I -> D) -> Prop
bitonic = \ f -> (i:I) -> (j:I) -> (k:I) -> (l:I) ->
                 (i < j /\ j < k /\ k < l) ->
                       (    ((meet (f i) (f k)) <= sup (f j) (f l)) 
                        /\  ((meet (f j) (f l)) <= sup (f i) (f k)))
        
inc : (I -> D) -> (I -> Prop) -> Prop
inc = \ f -> \ P -> (i:I) -> (j:I) -> ((P i /\ P j /\ (i < j)) ==> f i <= f j)

dec : (I -> D) -> (I -> Prop) -> Prop
dec = \ f -> \ P -> (i:I) -> (j:I) -> ((P i /\ P j /\ (i < j)) ==> f j <= f i)

Part1 : I -> Prop
Part2 : I -> Prop

axP12 : (i:I) -> (j:I) -> ((Part1 i \/ Part2 i) /\ (Part1 i /\ Part2 j ==> i < j) /\ (Part1 i <=> Not (Part2 i)))

rem1P12 : (i:I) -> (j:I) -> (Part1 i /\ j < i ==> Part1 j)
rem1P12 = \ i -> \ j -> fol-plugin(axP12,axI)

rem2P12 : (i:I) -> (j:I) -> (Part2 i /\ i < j ==> Part2 j)
rem2P12 = \ i -> \ j -> fol-plugin(axP12,axI)


lemma : (f:I -> D) -> inc f Part1 -> dec f Part2 -> bitonic f
lemma = \ f -> \ h1 -> \ h2 -> \ i -> \ j -> \ k -> \ l -> \ h -> 
        let 
         rem1 : (Part1 k) \/ (Part2 j) \/ (Part1 j /\ Part2 k)
         rem1 = fol-plugin(axP12)
         rem2 : (f i <= f j /\ f j <= f k) \/ (f i <= f j /\ f l <= f k) \/ (f l <= f k /\ f k <= f j)
         rem2 = fol-plugin(axI,rem1,rem1P12,rem2P12,h1,h2,h)
        in
         fol-plugin(rem2,lemD1,lemD2,lemD3,lemD4)
