--- the second property needed for the correctness of bitonic sort ---

-- # import Property

D : Set
(<=) : D -> D -> Prop
meet : D -> D -> D
sup : D -> D -> D

infix 6 <=

ref  : (x : D) -> (y:D) -> (x <= y /\ y <= x   <=>   Eq D x y)
axM : (x : D) -> (y : D) -> (z : D) ->
	      ( z <= meet x y	<=>
		z <= x /\ z <= y
	      )
axS : (x : D) -> (y : D) -> (z : D) ->
	      ( sup x y	<= z <=>
		x <= z /\ y <= z
	      )

remM1 : (x:D) -> (y:D) -> meet x y <= x
remM1 = \ x -> \ y -> fol-plugin(ref,axM)

remS1 : (x:D) -> (y:D) -> x <= sup x y
remS1 = \ x -> \ y -> fol-plugin(ref,axS)

--- trans can be derived
--- notice that distributivity is not needed

trans : (x:D) -> (y:D) -> (z:D) -> (x <= y /\ y <= z ==> x <= z)

remMS : (x:D) -> (y:D) -> meet x y <= sup x y
remMS = \ x -> \ y -> fol-plugin(remM1,remS1,trans)

-- the index set ---

I : Set
(<) : I -> I -> Prop

LO : (I:Set) -> (I->I->Prop) -> Prop
LO = \ I -> \ R -> (i:I) -> (j:I) -> (k:I) ->
        (
            (R i j /\ R j k ==> R i k) 
         /\ (R i j \/ Eq I i j \/ R j i)
         /\ Not (R i i)
        )

axI : LO I (<)

bitonic : (I -> D) -> Prop
bitonic = \ f -> (i:I) -> (j:I) -> (k:I) -> (l:I) ->
                 (i < j /\ j < k /\ k < l) ==> 
                       (    ((meet (f i) (f k)) <= sup (f j) (f l)) 
                        /\  ((meet (f j) (f l)) <= sup (f i) (f k)))

--- another indexed set with two functions

J : Set
(<<) : J -> J -> Prop

axJ : LO J (<<)

inl : J -> I
inr : J -> I

axJI : (j1:J) -> (j2:J) -> inl j1 < inr j2

incInl : (j1:J) -> (j2:J) -> j1 << j2 ==> inl j1 < inl j2
incInr : (j1:J) -> (j2:J) -> j1 << j2 ==> inr j1 < inr j2

lem : (f:I -> D) -> bitonic f -> (j1:J) -> (j2:J) ->
             meet (f (inl j1)) (f (inr j1)) <= sup (f (inl j2)) (f (inr j2))
lem = \ f -> \ h -> \ j1 -> \ j2 ->
            let 
             rem : (j1 << j2 \/ j2 << j1 \/ Eq J j1 j2)
             rem = fol-plugin(axJ)
            in
             fol-plugin(h,axJI,rem,incInl,incInr,remMS)



