
-- # import Set
-- # import Prop
-- # import Order

data Acc' {A:Setoid}(R:StrictPartialOrder A)(x:El A) : Prop where
  acc : ((y:El A) -> Prf (R.rel y x) -> Acc' R y) -> Acc' R x

Acc (A:Setoid) : StrictPartialOrder A -> El A -> PROP
Acc R x = mkPROP (Acc' R x)

WellFounded (A:Setoid) : (R:StrictPartialOrder A) -> PROP
WellFounded R = ForAll $ \x -> Acc R x

sig WellOrdering (A:Setoid) : Type extends StrictPartialOrder where
  wf : Prf (WellFounded (mkStrictPartialOrder (mkRel rel)
					      irrefl asym
					      trans respeq) )

wellFoundedInduction (A:Setoid)(R:WellOrdering A) :
  (P : Pred A) ->
  Prf (
    (ForAll $ \x -> (ForAll $ \y -> R.rel y x ==> P.pred y) ==> P.pred x)
    ==> ForAll (\x -> P.pred x)
  )
wellFoundedInduction {A} {R} P step x = wf x (R.wf x)
  where
    wf : (z:El A) -> Prf (Acc R z ==> P.pred z)
    wf z (acc h) = step z $ \y "y<z" -> wf y (h y "y<z")

