-- Proofs about the prelude functions
-- Author :: Ulf Norell
-- Created:: 2004-12-14

-- # import Prelude
-- # import Property
-- # import Monoid
-- # import Functor
-- # import Monad
-- # import Equality

-- Extensional equality for functions -------------------------------------
-- Can't be proven inside the system(?)
extensionality' : (A : Set) -> (B : A -> Set)         ->
                  (f, g : (x : A) -> B x)             ->
                  ((x : A) -> f x == g x)  ->
                  f == g
extensionality_ :(A, B : Set)                     ->
                  (f, g : A -> B)                 ->
                  ((x : A) -> f x == g x)  ->
                  f == g
extensionality_ A B = extensionality' A (\ _ -> B)

-- Pairs are unlifted
propUnliftedPairs_ : (A : Set) -> (B : Set) -> (p : {A;B}) ->
                        p == (p.1,p.2)
propUnliftedPairs_ A B (x,y) = fol-plugin()

-- (A -> A, id, compose) is a monoid --------------------------------------
monoidLawsIdCompose : (A:Set) -> MonoidLaws (A -> A) id (<>)
monoidLawsIdCompose A = struct
  id    = struct left  = reflexivity 
                 right = reflexivity
  assoc = \f g h -> reflexivity (\x -> f (g (h x)))
  

monoidIdCompose : (A:Set) -> Monoid (A -> A)
monoidIdCompose A = struct
  ops    = struct zero = id
                  plus = (<>)
  proofs = monoidLawsIdCompose A
  

-- The identity monad -----------------------------------------------------
monadId : Monad Id
monadId = struct
  ops    = struct {return = \A-> id; bind = \A B x f -> f x}
  proofs = struct
    law1 = \A     m     -> reflexivity m
    law2 = \A B   x f   -> reflexivity (f x)
    law3 = \A B C m g h -> reflexivity (h (g m))

-- The identity functor ---------------------------------------------------
functorId : Functor Id
functorId = struct
  map    = \A B -> id
  proofs = struct 
    id      = \A          -> reflexivity id
    compose = \A B C f g  -> reflexivity (f<>g)
